/*
 * QU-PROLOG COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
 * 
 * Copyright 1993 by The University of Queensland, Queensland 4072 Australia
 * 
 * Permission to use, copy and distribute this software 
 * for any non-commercial purpose and without fee is hereby
 * granted, provided that the above copyright notice
 * and this permission notice and warranty
 * disclaimer appear in all copies and in supporting documentation, 
 * and that the name of The University of Queensland not be used in 
 * advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission.
 * 
 * Source code modifications are prohibited except where written agreement 
 * has been given in advance by The University of Queensland.
 * 
 * The University of Queensland disclaims all warranties with regard to this
 * software, including all implied warranties of merchantability and fitness.
 * In no event shall The University of Queensland be liable for any special,
 * indirect or consequential damages or any damages whatsoever resulting from
 * loss of use, data or profits, whether in an action of contract, negligence
 * or other tortious action, arising out of or in connection with the use or
 * performance of this software.
 */

#include "cells.h"
#include "errors.h"
#include "x_registers.h"

global	VALUE	*x;
global	natural	num_x_registers = DEFAULT_NUM_X_REGISTERS;

/*----------------------------------------------------------------------------
    allocate memory for the x registers.
----------------------------------------------------------------------------*/
global	void
initialise_x_registers(void)
{
	natural	i;

	if ((x = (VALUE *) malloc(num_x_registers * sizeof(VALUE))) == NULL)
		fatal("not enough memory for %d x registers",
		    num_x_registers);
	for (i = 0; i < num_x_registers; i++)
		InitXV(i);
}
